<?xml version="1.0"?>



<xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	  
<xsl:template match="FaultTree">
  
<TABLE id="TopEventDataTable" cellSpacing="1">
						<TR>
							<TD class="TopEventsLabel">
								Top Event (Effect)
							</TD>
							<TD class="TopEventsData">
								<xsl:value-of select="Name" /><xsl:text xml:space="preserve">&#xA0;&#xA0;&#xA0;</xsl:text>
								<xsl:element name="a"> 
									<xsl:attribute name="href">
                    <xsl:variable name="name">
                      <xsl:call-template name="string-replace-all">
                        <xsl:with-param name="text" select="Name" />
                        <xsl:with-param name="replace" select="'::'" />
                        <xsl:with-param name="by" select="'!!'" />
                      </xsl:call-template>
                    </xsl:variable>


                    FaultTrees/HTML/<xsl:value-of select="$name" />_FaultTree.html
									</xsl:attribute> 
									<xsl:attribute name="onclick"> 
										return popup(this, 'FaultTreeWindow');
									</xsl:attribute>Click here to display fault tree in a new window</xsl:element> 
								
								
							
								
							</TD>
						</TR>
						<TR>
							<TD class="TopEventsLabel">
								Description
							</TD>
							<TD class="TopEventsData">
                   <xsl:apply-templates select="Description"/>
							</TD>
						</TR>
  <xsl:variable name="field-name" select="@name" />

  <xsl:variable name="performQuantAnalysis">
    <xsl:choose>
      <xsl:when test="Unavailability">
        <xsl:value-of select="true()"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="false()"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
 
  <xsl:if test="$performQuantAnalysis='true'">
    <TR>
      <TD class="TopEventsLabel">
        System Unavailability
      </TD>
      <TD class="TopEventsData">
        <xsl:value-of select="Unavailability" />
      </TD>
    </TR>
  </xsl:if>
  <xsl:if test="Severity">
    <TR>
      <TD class="TopEventsLabel">
        Severity
      </TD>
      <TD class="TopEventsData">
        <xsl:value-of select="Severity" />
      </TD>
    </TR>
    </xsl:if>
              
              <TR>   
							<TD class="TopEventsLabel">
								Number Of Cut Sets
							</TD>
							<TD class="TopEventsData">
								<xsl:value-of select="NumberOfCutSets" />
							</TD>
						</TR>
					</TABLE>
</xsl:template>
  <xsl:template match="Description">
    <xsl:choose>
    <xsl:when test="TextBlock">
      <xsl:apply-templates/>
    </xsl:when>
      <xsl:otherwise>
                <xsl:text>N/A</xsl:text>
          </xsl:otherwise>
        
    </xsl:choose>
    

  </xsl:template>

  <xsl:template match="TextBlock">

    <xsl:variable name="string" select="." />
    <xsl:variable name="str-length" select="string-length($string)" />
    <xsl:choose>
      <xsl:when test="$str-length != 0">
        <xsl:value-of select="$string" />
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>N/A</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
   
   
  </xsl:template>

  <xsl:template match="LineBreak">
    <br/>
  </xsl:template>
  
  
  <xsl:template name="string-replace-all">
    <xsl:param name="text" />
    <xsl:param name="replace" />
    <xsl:param name="by" />
    <xsl:choose>
      <xsl:when test="contains($text, $replace)">
        <xsl:value-of select="substring-before($text,$replace)" />
        <xsl:value-of select="$by" />
        <xsl:call-template name="string-replace-all">
          <xsl:with-param name="text"
          select="substring-after($text,$replace)" />
          <xsl:with-param name="replace" select="$replace" />
          <xsl:with-param name="by" select="$by" />
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$text" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>


</xsl:stylesheet>